#!/usr/bin/perl
#
################################################################################
#
# IPCop Dialin Server CGI
#
# Copyright (C) 2007 Olaf (weizen_42) Westrik
#
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 
#
# You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 
#
#
# Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License, wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version. 
#
# Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 
#
# Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
#
################################################################################
#
# For support post / read in http://www.ipcop-forum.de
#
# $Id: dialinserver.cgi 287 2007-11-01 09:06:25Z weizen_42 $
#
# Revision history:
#
# 2007-10-xx created by weizen_42 for dialin AddOn
#


use strict;
use LWP::UserAgent;

# enable only the following on debugging purpose
use warnings;
use CGI::Carp 'fatalsToBrowser';

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my $version = 'v0.1.0';
my $debug = 0;

# checking for new version
my $addonname = 'dialin';
my $onlineversion = '';
my $onlinelink = '';
my $timestamplastcheck = '/var/ipcop/dialinserver/lastcheck';
my $flagdonotcheck = '/var/ipcop/dialinserver/noversioncheck';

# get rid of used only once warnings
my @onlyonce = ( );
undef @onlyonce;

my $line = '';
my $errormessage = '';
my $status_started = "<td align='center' bgcolor='${Header::colourgreen}'><font color='white'><b>$Lang::tr{'running'}</b></font></td>";
my $status_stopped = "<td align='center' bgcolor='${Header::colourred}'><font color='white'><b>$Lang::tr{'stopped'}</b></font></td>";


&Header::showhttpheaders();
my %hashcgi = ();
$hashcgi{'ACTION'} = '';                # save

my %hashnet = ();
my %hashdialin = ();
my %isdnsettings = ();

$hashcgi{"DIALIN_ENABLED"}          = "off";          # off, on
$hashcgi{"DIALIN_ALLOWED"}          = "";
$hashcgi{"DIALIN_PASSWORD"}         = "";
$hashcgi{"DIALIN_IPPPD_DEBUG"}      = "";             # off, on
$hashcgi{"DIALIN_LOCAL_IP"}         = "";
$hashcgi{"DIALIN_REMOTE_IP"}        = "";
$hashcgi{"DIALIN_NETMASK"}          = "";
$hashcgi{"DIALIN_COPDNS"}           = "off";
$hashcgi{"DIALIN_COPPROXY"}         = 0;
$hashcgi{"DIALIN_TRANSPARENT"}      = "off";
$hashcgi{"DIALIN_REDHTTP"}          = "off";
$hashcgi{"DIALIN_REDALL"}           = "off";
$hashcgi{"DIALIN_NOGREEN"}          = "on";

$hashdialin{"DIALIN_DEVICE"}        = "disabled";     # disabled, ippp1
$hashdialin{"DIALIN_ALLOWED"}       = "";
$hashdialin{"DIALIN_PASSWORD"}      = "dialin";
$hashdialin{"DIALIN_IPPPD_DEBUG"}   = "";             # "", debug
$hashdialin{"DIALIN_LOCAL_IP"}      = "192.168.101.1";
$hashdialin{"DIALIN_REMOTE_IP"}     = "192.168.101.2";
$hashdialin{"DIALIN_NETMASK"}       = "255.255.255.0";
$hashdialin{"DIALIN_COPDNS"}        = "off";
$hashdialin{"DIALIN_COPPROXY"}      = 0;
$hashdialin{"DIALIN_TRANSPARENT"}   = "off";
$hashdialin{"DIALIN_REDHTTP"}       = "off";
$hashdialin{"DIALIN_REDALL"}        = "off";
$hashdialin{"DIALIN_NOGREEN"}       = "on";


&Header::getcgihash(\%hashcgi);
&General::readhash("${General::swroot}/ethernet/settings", \%hashnet);
&General::readhash("${General::swroot}/dialinserver/settings", \%hashdialin);
&General::readhash("${General::swroot}/isdn/settings", \%isdnsettings);


if ( $isdnsettings{'ENABLED'} ne 'on' )
{
  &Header::openpage("Dialin Server", 1, '');
  &Header::openbigbox('100%', 'left', '', '');

  &Header::openbox('100%', 'left', $Lang::tr{'info'});
  print "<class name='base'>ISDN is not configured. Configure first using setup.</class>\n";
  &Header::closebox();

  &Header::closebigbox();
  &Header::closepage();
  exit 0;
}


if ( $hashcgi{'ACTION'} eq 'save' ) 
{
  if ( $hashcgi{"DIALIN_ENABLED"} eq 'on' )
  {
    $hashcgi{"DIALIN_DEVICE"} = "ippp0";
    unless( &General::validip($hashcgi{"DIALIN_LOCAL_IP"}) )
    {
      $errormessage = $Lang::tr{'dialin error ip'}." (".$hashcgi{"DIALIN_LOCAL_IP"}.")";
      goto ERROREXIT;
    }
    unless( &General::validip($hashcgi{"DIALIN_REMOTE_IP"}) )
    {
      $errormessage = $Lang::tr{'dialin error ip'}." (".$hashcgi{"DIALIN_REMOTE_IP"}.")";
      goto ERROREXIT;
    }
    unless( &General::validmask($hashcgi{"DIALIN_NETMASK"}) )
    {
      $errormessage = $Lang::tr{'dialin error netmask'};
      goto ERROREXIT;
    }
    unless ( &General::IpInSubnet($hashcgi{"DIALIN_LOCAL_IP"}, $hashcgi{"DIALIN_REMOTE_IP"}, $hashcgi{"DIALIN_NETMASK"}) )
    {
      $errormessage = $Lang::tr{'dialin error ip'}." (".$hashcgi{"DIALIN_REMOTE_IP"}.")";
      goto ERROREXIT;
    }
    if ( &General::IpInSubnet($hashcgi{"DIALIN_LOCAL_IP"}, $hashnet{"GREEN_ADDRESS"}, $hashnet{"GREEN_NETMASK"}) )
    {
      $errormessage = $Lang::tr{'dialin error green'}." (".$hashcgi{"DIALIN_LOCAL_IP"}.")";
      goto ERROREXIT;
    }
    if ( ($hashnet{"BLUE_DEV"} ne "") && &General::IpInSubnet($hashcgi{"DIALIN_LOCAL_IP"}, $hashnet{"BLUE_ADDRESS"}, $hashnet{"BLUE_NETMASK"}) )
    {
      $errormessage = $Lang::tr{'dialin error blue'}." (".$hashcgi{"DIALIN_LOCAL_IP"}.")";
      goto ERROREXIT;
    }
    if ( ($hashnet{"ORANGE_DEV"} ne "") && &General::IpInSubnet($hashcgi{"DIALIN_LOCAL_IP"}, $hashnet{"ORANGE_ADDRESS"}, $hashnet{"ORANGE_NETMASK"}) )
    {
      $errormessage = $Lang::tr{'dialin error orange'}." (".$hashcgi{"DIALIN_LOCAL_IP"}.")";
      goto ERROREXIT;
    }
    if ( $hashcgi{"DIALIN_TRANSPARENT"} eq 'on' && $hashcgi{"DIALIN_COPPROXY"} == 0 )
    {
      $errormessage = $Lang::tr{'dialin no proxyport'};
      goto ERROREXIT;
    }
  }
  else
  {
    $hashcgi{"DIALIN_ENABLED"} = "off";
    $hashcgi{"DIALIN_DEVICE"} = "disabled";
  }

  if ( $hashdialin{"DIALIN_ENABLED"} ne 'off' ) 
  {
    # IFace was enabled -> down
    system("/usr/local/bin/dialinctrl stop >/dev/null 2>&1");
    sleep(1);
  }

  $hashdialin{"DIALIN_ENABLED"}     = $hashcgi{"DIALIN_ENABLED"};
  $hashdialin{"DIALIN_ALLOWED"}     = $hashcgi{"DIALIN_ALLOWED"};
  $hashdialin{"DIALIN_DEVICE"}      = $hashcgi{"DIALIN_DEVICE"};
  $hashdialin{"DIALIN_PASSWORD"}    = $hashcgi{"DIALIN_PASSWORD"};
  $hashdialin{"DIALIN_LOCAL_IP"}    = $hashcgi{"DIALIN_LOCAL_IP"};
  $hashdialin{"DIALIN_REMOTE_IP"}   = $hashcgi{"DIALIN_REMOTE_IP"};
  $hashdialin{"DIALIN_NETMASK"}     = $hashcgi{"DIALIN_NETMASK"};
  $hashdialin{"DIALIN_COPDNS"}      = $hashcgi{"DIALIN_COPDNS"};
  $hashdialin{"DIALIN_COPPROXY"}    = $hashcgi{"DIALIN_COPPROXY"};
  $hashdialin{"DIALIN_TRANSPARENT"} = $hashcgi{"DIALIN_TRANSPARENT"};
  $hashdialin{"DIALIN_REDHTTP"}     = $hashcgi{"DIALIN_REDHTTP"};
  $hashdialin{"DIALIN_REDALL"}      = $hashcgi{"DIALIN_REDALL"};
  $hashdialin{"DIALIN_NOGREEN"}     = $hashcgi{"DIALIN_NOGREEN"};
  $hashdialin{"DIALIN_IPPPD_DEBUG"} = $hashcgi{"DIALIN_IPPPD_DEBUG"} eq 'on' ? 'debug' : '';

  &General::writehash("${General::swroot}/dialinserver/settings", \%hashdialin);

  if ( $hashdialin{"DIALIN_ENABLED"} eq 'on' ) 
  {
    system("/usr/local/bin/dialinctrl start >/dev/null 2>&1");
    sleep(1);
  }
}
ERROREXIT:


&Header::openpage("Dialin Server", 1, '');

&Header::openbigbox('100%', 'left', '', $errormessage);

if ( $errormessage )
{
  &Header::openbox('100%', 'left', $Lang::tr{'error messages'});
  print "<class name='base'>$errormessage\n";
  print "&nbsp;</class>\n";
  &Header::closebox();
}


# Found this usefull piece of code in BlockOutTraffic AddOn  8-)
#   fwrules.cgi
###############
# DEBUG DEBUG
if ( $debug )
{
&Header::openbox('100%', 'left', 'DEBUG');
my $debugCount = 0;
foreach my $line (sort keys %hashcgi) {
  print "$line = $hashcgi{$line}<br />\n";
  $debugCount++;
}
print "&nbsp;Count: $debugCount\n";
&Header::closebox();
}
# DEBUG DEBUG
###############


#
# Check for new version
#
&checkfornewversion($addonname, $version);
if ( $onlineversion ne '' )
{
  &Header::openbox('100%', 'left', $Lang::tr{'info'});
  print <<END
<table width="100%"><tr>
<td>$Lang::tr{'dialin newversion'} <a href="$onlinelink" target="_blank"><b>$onlineversion</b></a></td>
</tr></table>
END
;
  &Header::closebox();
}

my $checked_enabled = "";
$checked_enabled = "checked='checked'" if ( $hashdialin{"DIALIN_ENABLED"} eq 'on' );
my $checked_ipppd_debug = "";
$checked_ipppd_debug = "checked='checked'" if ( $hashdialin{"DIALIN_IPPPD_DEBUG"} eq 'debug' );
my $checked_copdns = "";
$checked_copdns = "checked='checked'" if ( $hashdialin{"DIALIN_COPDNS"} eq 'on' );
my $checked_transparent = "";
$checked_transparent = "checked='checked'" if ( $hashdialin{"DIALIN_TRANSPARENT"} eq 'on' );
my $checked_redhttp = "";
$checked_redhttp = "checked='checked'" if ( $hashdialin{"DIALIN_REDHTTP"} eq 'on' );
my $checked_redall = "";
$checked_redall = "checked='checked'" if ( $hashdialin{"DIALIN_REDALL"} eq 'on' );
my $checked_nogreen = "";
$checked_nogreen = "checked='checked'" if ( $hashdialin{"DIALIN_NOGREEN"} eq 'on' );


&Header::openbox('100%', 'left', "Dialin Server");

print "<form method='post' action='$ENV{'SCRIPT_NAME'}'><table width='100%'>";
print "<tr><td width='30%' class='base'><b>Dialin Server</b></td>";
if ( -e "/var/run/dialinserver.pid" )
{
  print $status_started;
}
else
{
  print $status_stopped;
}
print "<td colspan='2'>&nbsp;</td></tr>";

print <<END
<tr><td colspan='4'>MSN: $isdnsettings{"MSN"}</td></tr>
<tr><td colspan='4'>Protocol / Type: $isdnsettings{"PROTOCOL"} / $isdnsettings{"TYPE"}</td></tr>
<tr><td colspan='4'><hr /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'enabled'}</td><td colspan='3'><input type='checkbox' name='DIALIN_ENABLED' $checked_enabled /></td>
<tr><td width='30%' class='base'>$Lang::tr{'dialin ALLOWED'}:&nbsp;<img src='/blob.gif' alt='*' /></td><td colspan='3'><input type='text' name='DIALIN_ALLOWED' value='$hashdialin{"DIALIN_ALLOWED"}' size='25'/></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'dialin PASSWORD'}:</td><td colspan='3'><input type='password' name='DIALIN_PASSWORD' value='$hashdialin{"DIALIN_PASSWORD"}' size='25' /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'dialin IPPPD_DEBUG'}:</td><td colspan='3'><input type='checkbox' name='DIALIN_IPPPD_DEBUG' $checked_ipppd_debug /></td>
<tr><td colspan='4'><hr /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'dialin LOCAL_IP'}:</td><td><input type='text' name='DIALIN_LOCAL_IP' value='$hashdialin{"DIALIN_LOCAL_IP"}' size='18' /></td>
    <td width='30%' class='base'>$Lang::tr{'dialin REMOTE_IP'}:</td><td><input type='text' name='DIALIN_REMOTE_IP' value='$hashdialin{"DIALIN_REMOTE_IP"}' size='18' /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'netmask'} (255.255.255.0):</td><td colspan='3'><input type='text' name='DIALIN_NETMASK' value='$hashdialin{"DIALIN_NETMASK"}' size='18' /></td></tr>
<tr><td colspan='4'><hr /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'dialin COPDNS'}:</td><td colspan='3'><input type='checkbox' name='DIALIN_COPDNS' $checked_copdns /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'dialin COPPROXY'}:&nbsp;<img src='/blob.gif' alt='*' /></td><td><input type='text' name='DIALIN_COPPROXY' value='$hashdialin{"DIALIN_COPPROXY"}' size='5'/></td>
    <td width='30%' class='base'>$Lang::tr{'dialin TRANSPARENT'}:</td><td width='20%'><input type='checkbox' name='DIALIN_TRANSPARENT' $checked_transparent /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'dialin REDHTTP'}:</td><td colspan='3'><input type='checkbox' name='DIALIN_REDHTTP' $checked_redhttp /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'dialin REDALL'}:</td><td colspan='3'><input type='checkbox' name='DIALIN_REDALL' $checked_redall /></td></tr>
<tr><td width='30%' class='base'>$Lang::tr{'dialin NOGREEN'}:</td><td colspan='3'><input type='checkbox' name='DIALIN_NOGREEN' $checked_nogreen /></td></tr>
END
;

print <<END
</table><hr /><table width='100%'>
<tr>
  <td width='70%' class='base' valign='top'><img src='/blob.gif' alt='*' />&nbsp; $Lang::tr{'dialin proxy usage'}</td>
  <td width='30%' align='center'><input type='submit' value='$Lang::tr{'save'}' /><input type='hidden' name='ACTION' value='save' />
</tr>
</table>
<hr />
<table width='100%'>
<tr>
	<td>&nbsp;</td>
	<td align='right'>
	<b><small><a href="http://www.ban-solms.de/t/IPCop.html" target="_blank">Dialin Server $version</a></small></b>
	</td>
</tr>
</table>
END
;
&Header::closebox();

&Header::closebigbox();
&Header::closepage();


sub checkfornewversion
{
  my $addon = shift;
  my $version = shift;
  $onlineversion = '';

  if ( -e $flagdonotcheck )
  {
    return;
  }

  # only check if we are online and last check was some time ago
  if ( (! -e '/var/ipcop/red/active') || (-e $timestamplastcheck) && (int(-M $timestamplastcheck) < 5) )
  {
    return;
  }

#workaround to suppress a warning when a variable is used only once
  my @dummy = ( $General::version );
  undef (@dummy);

  my $ua = LWP::UserAgent->new;
  $ua->timeout(120);
  $ua->agent("Mozilla/4.0 (compatible; IPCop $General::version; $version)");
  my $content = $ua->get("http://ipcop-addons.ath.cx/version/$addon");

  if ( $content->is_success )
  {
    # compare the versions, format is v1.2.3
    $content->content =~ /v(\d+).(\d+).(\d+)/;
    my $ver1 = $1;
    my $ver2 = $2;
    my $ver3 = $3;

    $version =~ /v(\d+).(\d+).(\d+)/;

    if ( ($ver1 > $1) || (($ver1 == $1) && ($ver2 > $2)) || (($ver1 == $1) && ($ver2 == $2) && ($ver3 > $3)) )
    {
      $onlineversion = "v$ver1.$ver2.$ver3";

      $content->content =~ /http(.*)/;
      $onlinelink = "http$1";
    }
    else
    {
      # no news, recheck in a couple of days
      system("touch $timestamplastcheck >/dev/null 2>&1");
    }
  }
}
